<?php
/*
 * Plugin Name: Songbird
 * Version: 1.0
 * Plugin URI: http://rvincent.digital-nerv.net/wordpress-plugins/
 * Description: Shows the current Songtitle you listen to in <a href="http://getsongbird.com/">Songbird</a> in association with <a href="http://addons.songbirdnest.com/addon/1485">Now Chirping</a>.
 * Author: Rally Vincent
 * Author URI: http://rvincent.digital-nerv.net/
 */
 
/*  Copyright 2009 Rally Vincent (email : rvincent at digital-nerv.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* l10n */
load_plugin_textdomain('songbird', "/wp-content/plugins/songbird/languages/");
 
$songbird_db_version = "1.0";

register_activation_hook(__FILE__,'songbird_install');

function songbird_install() {
	global $wpdb;
	global $songbird_db_version;
	$table_name = $wpdb->prefix . "songbird";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		$sql = "CREATE TABLE " . $table_name . " (
			id bigint(20) NOT NULL auto_increment,
			user varchar(255) default NULL,
			created timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			artist varchar(255) default NULL,
			title varchar(255) default NULL,
			album varchar(255) default NULL,
			rating int(10) default NULL,
			composer varchar(255) default NULL,
			year int(10) default NULL,
			genre varchar(255) default NULL,
			PRIMARY KEY (id)
		);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);

		add_option("songbird_db_version", $songbird_db_version);
	}
}

class SongbirdWidget extends WP_Widget {

	function SongbirdWidget() {
		$widget_ops = array('classname' => 'SongbirdWidget', 'description' => __("Shows the current Title you listen to in Songbird.", "songbird") );
		$control_ops = array('width' => 300, 'height' => 300);
		$this->WP_Widget('songbird', __("Songbird", "songbird"), $widget_ops, $control_ops);
	}

	function widget($args, $instance){
		global $wpdb;
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '&nbsp;' : $instance['title']);
		$user = empty($instance['user']) ? '&nbsp;' : $instance['user'];
		echo $before_widget;
		if ( $title )
		echo $before_title . $title . $after_title;
		$table_name = $wpdb->prefix . "songbird";
		$sql = "SELECT * FROM " . $table_name . " WHERE user = \"" . strtolower($instance['user']) . "\" LIMIT 0, 1;";
		$results = $wpdb->get_results($sql);
		if ($results) {
			foreach ($results as $result) {
			?>
				<p style="text-align: left;">&bdquo;<?php echo $result->title; ?>&ldquo;</p>
			<?php
				if ($result->artist != "null") {
			?>
				<p style="text-align: right;"><em><?php echo $result->artist; ?></em></p>
			<?php
				}
			}
		}
		echo $after_widget;
	}
	function update($new_instance, $old_instance){
		$instance = $old_instance;
		$instance['title'] = strip_tags(stripslashes($new_instance['title']));
		$instance['user'] = strip_tags(stripslashes($new_instance['user']));
		return $instance;
	}
	function form($instance){
		$instance = wp_parse_args( (array) $instance, array('title'=>'Songbird', 'user'=>'user') );
		$title = htmlspecialchars($instance['title']);
		$user = htmlspecialchars($instance['user']);
		echo "<p><label for=\"" . $this->get_field_name("title") . "\">" . _e("Title:", "songbird") . "</label> <input class=\"widefat\" id=\"" . $this->get_field_id("title") . "\" name=\"" . $this->get_field_name("title") . "\" type=\"text\" value=\"" . $title . "\" /></p>\n";
		echo "<p><label for=\"" . $this->get_field_name("user") . "\">" . _e("Username:", "songbird") . "</label> <input class=\"widefat\" id=\"" . $this->get_field_id("user") . "\" name=\"" . $this->get_field_name("user") . "\" type=\"text\" value=\"" . $user . "\" /></p>\n";
	}
}
function SongbirdWidgetInit() { register_widget('SongbirdWidget'); }
add_action('widgets_init', 'SongbirdWidgetInit');
?>
